import { BardDetails, GlobalConfig } from '../types';
import {
  GoogleSpreadsheet,
  GoogleSpreadsheetWorksheet,
} from 'google-spreadsheet';
import {
  Bot,
  useManualMessageSending,
  sendTimedClues,
  sendTimedRandomMessages,
} from '../common';

export class Bard extends Bot<BardDetails> {
  phrasesSheet: GoogleSpreadsheetWorksheet;
  stemsSheet: GoogleSpreadsheetWorksheet;
  constructor(config: GlobalConfig, spreadsheet: GoogleSpreadsheet) {
    const botConfig = config.bots.bard;
    super(botConfig, config.generalChannelId);
    this.phrasesSheet =
      spreadsheet.sheetsById[this.config.details.sheetIds.phrases];
    this.stemsSheet =
      spreadsheet.sheetsById[this.config.details.sheetIds.stems];

    this.discordClient.on('message', async message => {
      useManualMessageSending.bind(this)(message);
    });

    this.init();
  }

  async init(): Promise<void> {
    await this.discordClient.login(this.config.token);
    sendTimedClues.bind(this)(this.config.details.clueHeader, [120, 240]);
    sendTimedRandomMessages.bind(this)([20, 120]);
  }
}
